洛谷p2910[USACO08OPEN] Clear And Present Danger S

题目描述

Farmer John is on a boat seeking fabled treasure on one of the N (1 <= N <= 100) islands conveniently labeled 1..N in the Cowribbean Sea.

The treasure map tells him that he must travel through a certain sequence A_1, A_2, ..., A_M of M (2 <= M <= 10,000) islands, starting on island 1 and ending on island N before the treasure will appear to him. He can visit these and other islands out of order and even more than once, but his trip must include the A_i sequence in the order specified by the map.

FJ wants to avoid pirates and knows the pirate-danger rating (0 <= danger <= 100,000) between each pair of islands. The total danger rating of his mission is the sum of the danger ratings of all the paths he traverses.

Help Farmer John find the least dangerous route to the treasure that satisfies the treasure map's requirement.

输入格式

* Line 1: Two space-separated integers: N and M

* Lines 2..M+1: Line i+1 describes the i_th island FJ must visit with a single integer: A_i

* Lines M+2..N+M+1: Line i+M+1 contains N space-separated integers that are the respective danger rating of the path between island i and islands 1, 2, ..., and N, respectively. The ith integer is always zero.

输出格式

* Line 1: The minimum danger that Farmer John can encounter while obtaining the treasure.

题意翻译

农夫约翰正驾驶一条小艇在牛勒比海上航行.

海上有 𝑁(1≤𝑁≤100)N(1≤N≤100) 个岛屿,用 11 到 𝑁N 编号.约翰从 11 号小岛出发,最后到达 𝑁N 号小岛.

一张藏宝图上说,如果他的路程上经过的小岛依次出现了 𝐴1,𝐴2,…,𝐴𝑀(2≤𝑀≤10000)A1​,A2​,…,AM​(2≤M≤10000) 这样的序列(不一定相邻),那他最终就能找到古老的宝藏. 但是,由于牛勒比海有海盗出没.约翰知道任意两个岛屿之间的航线上海盗出没的概率,他用一个危险指数 𝐷𝑖,𝑗(0≤𝐷𝑖,𝑗≤100000)Di,j​(0≤Di,j​≤100000) 来描述.他希望他的寻宝活动经过的航线危险指数之和最小.那么,在找到宝藏的前提下,这个最小的危险指数是多少呢?

输入输出格式

输入格式:

第一行:两个用空格隔开的正整数 𝑁N 和 𝑀M。

第二到第 𝑀+1M+1 行:第 𝑖+1i+1 行用一个整数 𝐴𝑖Ai​ 表示 FJ 必须经过的第 𝑖i 个岛屿

第 𝑀+2M+2 到第 𝑁+𝑀+1N+M+1 行:第 𝑖+𝑀+1i+M+1 行包含 𝑁N 个用空格隔开的非负整数分别表示 𝑖i 号小岛到第 1…𝑁1…N 号小岛的航线各自的危险指数。保证第 𝑖i 个数是 00。

输出格式 第一行:FJ 在找到宝藏的前提下经过的航线的危险指数之和的最小值。

说明 这组数据中有三个岛屿,藏宝图要求 FJ 按顺序经过四个岛屿:11 号岛屿、22 号岛屿、回到 11 号岛屿、最后到 33 号岛屿。每条航线的危险指数也给出了:航路(1,2),(2,3),(3,1)(1,2),(2,3),(3,1) 和它们的反向路径的危险指数分别是 5,2,15,2,1。

FJ 可以通过依次经过 1,3,2,3,1,31,3,2,3,1,3 号岛屿以 77 的最小总危险指数获得宝藏。这条道路满足了奶牛地图的要求 (1,2,1,3)(1,2,1,3)。我们避开了 11 号和 22 号岛屿之间的航线,因为它的危险指数太大了。

注意:测试数据中 𝑎a 到 𝑏b 的危险指数不一定等于 𝑏b 到 𝑎a 的危险指数!

Translated by @LJC00125

输入输出样例

输入 #

3 4 
1 
2 
1 
3 
0 5 1 
5 0 2 
1 2 0 

输出 #

7 

说明/提示

There are 3 islands and the treasure map requires Farmer John to visit a sequence of 4 islands in order: island 1, island 2, island 1 again, and finally island 3. The danger ratings of the paths are given: the paths (1, 2); (2, 3); (3, 1) and the reverse paths have danger ratings of 5, 2, and 1, respectively.

He can get the treasure with a total danger of 7 by traveling in the sequence of islands 1, 3, 2, 3, 1, and 3. The cow map's requirement (1, 2, 1, and 3) is satisfied by this route. We avoid the path between islands 1 and 2 because it has a large danger rating.

输入输出格式

输入格式:

第一行:两个用空格隔开的正整数N和M

第二到第M+1行:第i+1行用一个整数Ai表示FJ必须经过的第i个岛屿

第M+2到第N+M+1行:第i+M+1行包含N个用空格隔开的非负整数分别表示i号小岛到第1...N号小岛的航线各自的危险指数。保证第i个数是0。

输出格式

第一行:FJ在找到宝藏的前提下经过的航线的危险指数之和的最小值。

说明

这组数据中有三个岛屿,藏宝图要求FJ按顺序经过四个岛屿:1号岛屿、2号岛屿、回到1号岛屿、最后到3号岛屿。每条航线的危险指数也给出了:航路(1,2)、(2,3)、(3,1)和它们的反向路径的危险指数分别是5、2、1。

FJ可以通过依次经过1、3、2、3、1、3号岛屿以7的最小总危险指数获得宝藏。这条道路满足了奶牛地图的要求(1,2,1,3)。我们避开了1号和2号岛屿之间的航线,因为它的危险指数太大了。

注意:测试数据中a到b的危险指数不一定等于b到a的危险指数!

此题是一道Floyd的板子题,核心思想是求出每个岛屿之间的最短路径,然后将考虑给到的经过路径,将最短路径相加即可。

Floyd算法:

此算法适合在数据不是很大的时候使用,因为这是多元节点的最短路径,所以每一边都要遍历。

  • 此算法的本质是动规算法,保存前一项的值。
  • 区别于Dj算法的建图,我们用领接矩阵建图,表示每个点之间的权值
  • 核心是在考虑x,y两点之间的路径时,找到另一个节点z,判断是x到y的距离短还是x先到z再到y的距离短。因为要考虑到特殊性,所以我们要将每一个点都作为踏板遍历一遍,加上遍历所有的边,所以时间复杂度为n的三次方,同时我们也要话n的平方的空间建图,所以不适合数据量很大的数。

此算法的核心步骤是:

dis[i][j] = min(dis[i][j], dis[i][k] + dis[k][j])

题目链接:P2910 [USACO08OPEN] Clear And Present Danger S - 洛谷 | 计算机科学教育新生态 (luogu.com.cn)

#include<iostream>
using namespace std;
int dis[105][105];
int a[10005];
int main()
{
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		cin >> a[i];
	}
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= n; j++) {
			cin >> dis[i][j];
		}
	}
	for (int k = 1; k <= n; k++) {
		for (int i = 1; i <= n; i++) {
			for (int j = 1; j <= n; j++) {
				dis[i][j] = min(dis[i][j], dis[i][k] + dis[k][j]);
			}
		}
	}
	int ans = 0;
	for (int i = 0; i < m - 1; i++) {
		ans += dis[a[i]][a[i + 1]];
	}
	cout << ans;
	return 0;
}

  • 31
    点赞
  • 15
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值